%define with_xom 1
%define resolverdir %{_sysconfdir}/java/resolver
%define gcj_support 0

Name:          saxon8
Version:       B.8.7
Release:       %mkrel 1
Summary:       Java XSLT processor
Group:         Development/Java
License:       MPL
Url:           http://saxon.sourceforge.net/
Source0:       http://download.sf.net/saxon/saxon-resources8-7.zip
Source1:       saxon8.saxon.script
Source2:       saxon8.saxonq.script
Source3:       saxon8.build.script
Source4:       saxon8.1
Source5:       saxon8q.1
Source6:       http://mirrors.ibiblio.org/pub/mirrors/maven/net.sf.saxon/poms/saxon-8.7.pom
Source7:       http://mirrors.ibiblio.org/pub/mirrors/maven/net.sf.saxon/poms/saxon-dom-8.7.pom
Source8:       http://mirrors.ibiblio.org/pub/mirrors/maven/net.sf.saxon/poms/saxon-jdom-8.7.pom
Source9:       http://mirrors.ibiblio.org/pub/mirrors/maven/net.sf.saxon/poms/saxon-sql-8.7.pom
Source10:      http://mirrors.ibiblio.org/pub/mirrors/maven/net.sf.saxon/poms/saxon-xom-8.7.pom
Source11:      http://mirrors.ibiblio.org/pub/mirrors/maven/net.sf.saxon/poms/saxon-xpath-8.7.pom

BuildRequires: ant
BuildRequires: bea-stax-api
BuildRequires: fop
BuildRequires: fop-javadoc
BuildRequires: java-devel
BuildRequires: java-javadoc
BuildRequires: jdom
BuildRequires: jdom-javadoc
BuildRequires: jpackage-utils
BuildRequires: xml-commons-apis
%if %with_xom
BuildRequires: xom
%endif
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:     noarch
%endif
Requires:      bea-stax-api
Requires:      bea-stax
Requires:      jaxp_parser_impl
Requires:      jpackage-utils
Provides:      jaxp_transform_impl
Requires:      update-alternatives
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The SAXON package is a collection of tools for processing XML documents.
The main components are:
- An XSLT processor, which implements the Version 1.0 XSLT and XPath
  Recommendations from the World Wide Web Consortium, found at
  http://www.w3.org/TR/1999/REC-xslt-19991116 and
  http://www.w3.org/TR/1999/REC-xpath-19991116 with a number of powerful
  extensions. This version of Saxon also includes many of the new features
  defined in the XSLT 1.1 working draft, but for conformance and portability
  reasons these are not available if the stylesheet header specifies
  version="1.0".
- A Java library, which supports a similar processing model to XSL, but allows
  full programming capability, which you need if you want to perform complex
  processing of the data or to access external services such as a relational
  database.
So you can use SAXON with any SAX-compliant XML parser by writing XSLT
stylesheets, by writing Java applications, or by any combination of the two.

%package scripts
Group:         Development/Java
Summary:       Utility scripts for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      avalon-logkit
Requires:      bea-stax-api
Requires:      bea-stax
Requires:      docbook-xsl-saxon
Requires:      xml-commons-apis
Requires:      xml-commons-resolver
Requires:      jpackage-utils


%description scripts
The SAXON package is a collection of tools for processing XML documents.

This package contains utility scripts for %{name}.

%package dom
Group:         Development/Java
Summary:       DOM support for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      jdom
Requires:      jpackage-utils

%description dom
The SAXON package is a collection of tools for processing XML documents.

Provides additional classes enabling Saxon to be used with 
the DOM Document Object Model. Supports using a DOM as the 
input or output of transformations and queries, and calling 
extension functions that use DOM interfaces to access a 
Saxon tree structure. Requires DOM level 3 (dom.jar, part 
of JAXP 1.3) to be on the classpath, if not running under 
JDK 1.5. 

%package jdom
Group:         Development/Java
Summary:       JDOM support for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      jpackage-utils

%description jdom
The SAXON package is a collection of tools for processing XML documents.

This package contains JDOM support for %{name}.

%package sql
Group:         Development/Java
Summary:       SQL support for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      jpackage-utils

%description sql
The SAXON package is a collection of tools for processing XML documents.

This package contains supports XSLT extensions for accessing and updating a
relational database from within a stylesheet.

%if %with_xom
%package xom
Group:         Development/Java
Summary:       XOM support for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      xom
Requires:      jpackage-utils

%description xom
The SAXON package is a collection of tools for processing XML documents.

Provides additional classes enabling Saxon to be used with 
XOM trees. Supports using a XOM document as the input or 
output of transformations and queries. Requires xom.jar on 
the classpath. 
%endif

%package xpath
Group:         Development/Java
Summary:       XPATH support for %{name}
Requires:      %{name} = %{version}-%{release}
Requires:      jpackage-utils

%description xpath
The SAXON package is a collection of tools for processing XML documents.

Provides support for the JAXP 1.3 XPath API. Requires the 
JAXP 1.3 version of jaxp-api.jar on the classpath, if not 
running under JDK 1.5. 

%package demo
Group:         Development/Java
Summary:       Demos for %{name}
Requires:      %{name} = %{version}-%{release}

%description demo
The SAXON package is a collection of tools for processing XML documents.

This package contains demonstrations and samples for %{name}.

%package manual
Group:         Development/Java
Summary:       Manual for %{name}

%description manual
The SAXON package is a collection of tools for processing XML documents.
This package contains manual for %{name}.

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
The SAXON package is a collection of tools for processing XML documents.

This package contains javadoc for %{name}

%prep
%setup -q -c

for j in $(find -name "*.jar"); do
  mv $j  $j.no
done

find -name "*.exe" -exec rm -rf {} \;

mkdir src
(
  cd src
  unzip -q ../source.zip
  find . -name CVS -exec rm -rf {} \;
  rm -rf net/sf/saxon/dotnet/
)

cp -p %{SOURCE3} ./build.xml
rm -rf docs/api
mkdir -p build/classes

%build
export CLASSPATH=$(build-classpath xml-commons-apis fop jdom dom4j bea-stax-ri bea-stax-api)
%if %with_xom
CLASSPATH=$CLASSPATH:$(build-classpath xom)
%endif
ant \
  -Dant.build.javac.source=1.5 \
  -Dant.build.javac.target=1.5 \
  -Dj2se.javadoc=%{_javadocdir}/java \
  -Dfop.javadoc=%{_javadocdir}/fop \
  -Djdom.javadoc=%{_javadocdir}/jdom

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
install -pm 644 build/lib/saxon8.jar \
  %{buildroot}%{_javadir}/saxon8-%{version}.jar

install -pm 644 build/lib/saxon8-xpath.jar \
  %{buildroot}%{_javadir}/saxon8-xpath-%{version}.jar

install -pm 644 build/lib/saxon8-dom.jar \
  %{buildroot}%{_javadir}/saxon8-dom-%{version}.jar

install -pm 644 build/lib/saxon8-jdom.jar \
  %{buildroot}%{_javadir}/saxon8-jdom-%{version}.jar
%if %with_xom
install -pm 644 build/lib/saxon8-xom.jar \
  %{buildroot}%{_javadir}/saxon8-xom-%{version}.jar
%endif
install -pm 644 build/lib/saxon8-sql.jar \
  %{buildroot}%{_javadir}/saxon8-sql-%{version}.jar

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_javadocdir}/saxon8-%{version}
cp -pr build/api/* %{buildroot}%{_javadocdir}/saxon8-%{version}
ln -s saxon8-%{version} %{buildroot}%{_javadocdir}/saxon8

mkdir -p %{buildroot}%{_datadir}/saxon8
cp -pr samples/* %{buildroot}%{_datadir}/saxon8

mkdir -p %{buildroot}%{_bindir}
sed 's,__RESOLVERDIR__,%{resolverdir},' < %{SOURCE1} > %{buildroot}%{_bindir}/saxon8
sed 's,__RESOLVERDIR__,%{resolverdir},' < %{SOURCE2} > %{buildroot}%{_bindir}/saxon8q

chmod 755 %{buildroot}%{_bindir}/*

mkdir -p %{buildroot}%{_mandir}/man1
sed 's,__RESOLVERDIR__,%{resolverdir},' < %{SOURCE4} > %{buildroot}%{_mandir}/man1/saxon8.1
sed 's,__RESOLVERDIR__,%{resolverdir},' < %{SOURCE5} > %{buildroot}%{_mandir}/man1/saxon8q.1

mkdir -p %{buildroot}%{_mavenpomdir}
%add_to_maven_depmap net.sf.saxon saxon %{version} JPP saxon8
install -pm 644 %{SOURCE6} %{buildroot}%{_mavenpomdir}/JPP-saxon8.pom
%add_to_maven_depmap net.sf.saxon saxon-dom %{version} JPP saxon8-dom
install -pm 644 %{SOURCE7} %{buildroot}%{_mavenpomdir}/JPP-saxon8-dom.pom
%add_to_maven_depmap net.sf.saxon saxon-jdom %{version} JPP saxon8-jdom
install -pm 644 %{SOURCE8} %{buildroot}%{_mavenpomdir}/JPP-saxon8-jdom.pom
%add_to_maven_depmap net.sf.saxon saxon-sql %{version} JPP saxon8-sql
install -pm 644 %{SOURCE9} %{buildroot}%{_mavenpomdir}/JPP-saxon8-sql.pom
%if %with_xom
%add_to_maven_depmap net.sf.saxon saxon-xom %{version} JPP saxon8-xom
install -pm 644 %{SOURCE10} %{buildroot}%{_mavenpomdir}/JPP-saxon8-xom.pom
%endif
%add_to_maven_depmap net.sf.saxon saxon-xpath %{version} JPP saxon8-xpath
install -pm 644 %{SOURCE11} %{buildroot}%{_mavenpomdir}/JPP-saxon8-xpath.pom

for i in doc/*.html; do
  tr -d \\r < $i > temp_file.html; mv temp_file.html $i
done

%if 0
%{__ln_s} %{_sysconfdir}/alternatives \
%{buildroot}%{_javadir}/jaxp_transform_impl.jar
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/jaxp_transform_impl.jar \
jaxp_transform_impl %{_javadir}/saxon8.jar 15

%preun
%update_maven_depmap
{
[ $1 -eq 0 ] || exit 0
%{_sbindir}/update-alternatives --remove jaxp_transform_impl %{_javadir}/saxon8.jar
} >/dev/null 2>&1 || :

%files
%{_javadir}/saxon8-%{version}.jar
%{_javadir}/saxon8.jar
%{_mavenpomdir}/JPP-saxon8.pom
%{_mavendepmapfragdir}/*
%if 0
%ghost %{_javadir}/jaxp_transform_impl.jar
%endif
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/java.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/java.so
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-%{version}.jar.so
%endif

%files scripts
%defattr(755,root,root,755) 
%{_bindir}/saxon8
%{_bindir}/saxon8q
%{_mandir}/man1/saxon8.1.xz
%{_mandir}/man1/saxon8q.1.xz

%files dom
%{_javadir}/saxon8-dom-%{version}.jar
%{_javadir}/saxon8-dom.jar
%{_mavenpomdir}/JPP-saxon8-dom.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-dom-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-dom-%{version}.jar.so
%endif

%files jdom
%{_javadir}/saxon8-jdom-%{version}.jar
%{_javadir}/saxon8-jdom.jar
%{_mavenpomdir}/JPP-saxon8-jdom.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-jdom-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-jdom-%{version}.jar.so
%endif

%files sql
%{_javadir}/saxon8-sql-%{version}.jar
%{_javadir}/saxon8-sql.jar
%{_mavenpomdir}/JPP-saxon8-sql.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-sql-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-sql-%{version}.jar.so
%endif

%if %with_xom
%files xom
%{_javadir}/saxon8-xom-%{version}.jar
%{_javadir}/saxon8-xom.jar
%{_mavenpomdir}/JPP-saxon8-xom.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-xom-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-xom-%{version}.jar.so
%endif
%endif

%files xpath
%{_javadir}/saxon8-xpath-%{version}.jar
%{_javadir}/saxon8-xpath.jar
%{_mavenpomdir}/JPP-saxon8-xpath.pom
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-xpath-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/saxon8-xpath-%{version}.jar.so
%endif

%files demo
%{_datadir}/saxon8

%files manual
%doc doc/*.html

%files javadoc
%{_javadocdir}/saxon8-%{version}
%{_javadocdir}/saxon8



%changelog
* Sun Aug 14 2011 dmorgan <dmorgan> B.8.7-1.mga2
+ Revision: 133030
- Fix groups
- Clean spec file

  + gil <gil>
    - imported package saxon8


* Sun Jul 03 2011 gil <gil> B.8.7-0.%%mkrel
- initial rpm